#include "ai8051u.h" 			//调用头文件
#include "stc32_stc8_usb.h"		//USB CDC 头文件
#include "intrins.h"            //调用头文件

#define u8 unsigned char
#define u16 unsigned int

char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";

u8 state = 0;					//初始状态为0
int i = 0;

void Delay20ms(void)	//@24.000MHz delay20ms Delay20ms();
{
	unsigned long edata i;

	_nop_();
	_nop_();
	i = 119998UL;
	while (i) i--;
}

void main (void)				//主函数
{  
	
    WTST = 0;  					//设置程序指令延时参数，赋值为0可将CPU执行指令的速度设置为最快
    EAXFR = 1; 					//扩展寄存器(XFR)访问使能
    CKCON = 0; 					//提高访问XRAM速度
	
	P_SW2 |= 0x80;              //B7位置1，使能访问XFR寄存器
	
	P0M0 = 0x00; P0M1 = 0x00; 	
    P1M0 = 0x00; P1M1 = 0x00; 
    P2M0 = 0x00; P2M1 = 0x00; 
    P3M0 = 0x00; P3M1 = 0x00; 
    P4M0 = 0x00; P4M1 = 0x00; 
    P5M0 = 0x00; P5M1 = 0x00; 
    P6M0 = 0x00; P6M1 = 0x00; 
    P7M0 = 0x00; P7M1 = 0x00; 	//将所有的端口都设置成准双向口，方便后期的使用。

	usb_init();					//USB CDC 接口配置
	
	IE2 |= 0x80;                //使能USB中断
    EA = 1; 					//EA |= 0X80;
	
	P40 = 1;					//打开LED开关
//	P0 = 0xff;
	
	while (DeviceState != DEVSTATE_CONFIGURED);     //等待USB完成配置
	
    while (1)
    {
        if (bUsbOutReady)					//如果接收到了一个数据
        {
            //USB_SendData(UsbOutBuffer,OutNumber);   //发送数据缓冲区，长度（接收数据原样返回, 用于测试）

            usb_OUT_done();					//清除当前的接收区
        }

		
		//test2：按一下47，一灯亮，再按一下，两个灯亮起来，直到P0全亮（变量+加法和乘法）
		if(P47 == 0)
		{
			Delay20ms();				//消抖
			if(P47 == 0)
			{
				state ++;
				if (state > 8) {
                    state = 0; // 限制最大值
                }
				P0 = (1 << state) - 1;
				printf("state:%d\r\n",(int)state);
				printf("灯亮灭情况:");
				for(i = 7; i >= 0; i--){
					printf("%c",((P0 & (1 << i)) ? '1' : '0'));
				}
			}
			while(P47 == 0);			//判断按键状态是不是改变了
		}
	}
}
		

		
		/*
		//demo1：按下按键47灯亮，松开灯灭。
		if(P47 == 0)
		{
			P00 = 0;
		}
		else
		{
			P00 = 1;
		}
		*/
		
		/*
		//demo2：按下按键47灯灭，松开灯亮。
		if(P47 == 0)
		{
			P00 = 1;
		}
		else
		{
			P00 = 0;
		}
		*/
		
		/*
		//demo3：按下按键47灯亮，松开灯灭。
		if(P47 == 0)
		{
			Delay20ms();				//消抖
			if(P47 == 0)
			{
				state = !state;				//变量取反 0 1 0 1 0 1
				P00 = 0;
				printf("state:%d\r\n",state);
				
				while(P47 == 0);			//判断按键状态是不是改变了
			}
		}
		*/
		
		/*
		//test1：按下32灯亮，按下33灯灭。
		if(P32 == 0)
		{
			Delay20ms();				//消抖
			if(P32 == 0)
			{
				P0 = 0x00;
				printf("state:%d\r\n",(int)state);
			}
		}
		if(P33 == 0)
		{
			Delay20ms();				//消抖
			if(P33 == 0)
			{
				P0 = 0xff;
				printf("state:%d\r\n",(int)state);
			}
		}
		没验证过代码，以后有实验箱了再说吧。
		*/
		